open Graphics
open Graph

type tfun = int -> int array -> int
type colfun = int -> color

val step : graph -> tfun -> int array -> int array

val draw_first : graph -> colfun -> int array -> unit

val draw_step : graph -> tfun -> colfun -> int array -> int array
