/* Gestion des nombres complexes */

typedef struct { double re, im; } cplx_t;

/* z1 <- z1 + z2 */
void cc_add (cplx_t *z1, cplx_t *z2);

/* z1 <- z1 - z2 */
void cc_sub (cplx_t *z1, cplx_t *z2);

/* z <- z * r */
void cr_mul (cplx_t *z, double x);

/* |z| */
double c_norm (cplx_t *z);

/* z <- ieme racine n-eme de 1 */
void ni_root (cplx_t *z, int n, int i); 

