type token =
    Edge
  | SemiColon
  | End
  | Eof
  | Newline
  | Int of ( int )

open Parsing
# 3 "gparser.mly"
  open Graph

  let n = ref (0)
  and d = ref (0)
  and tab_of_list size def l =
    let tab = Array.make size def 
    and i = ref (0)
    in 
      begin
	List.iter (fun x -> tab.(!i) <- x; i := !i + 1) l;
	tab
      end

(* Line 17, file gparser.ml *)
let yytransl_const = [|
  257 (* Edge *);
  258 (* SemiColon *);
  259 (* End *);
  260 (* Eof *);
  261 (* Newline *);
    0|]

let yytransl_block = [|
  262 (* Int *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\002\000\003\000\004\000\004\000\005\000\005\000\
\000\000\000\000"

let yylen = "\002\000\
\004\000\005\000\002\000\003\000\001\000\002\000\001\000\002\000\
\002\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\009\000\000\000\010\000\000\000\
\000\000\000\000\005\000\007\000\000\000\003\000\000\000\000\000\
\004\000\008\000\006\000\000\000\001\000\002\000"

let yydgoto = "\003\000\
\005\000\007\000\008\000\014\000\015\000"

let yysindex = "\002\000\
\003\255\004\255\000\000\010\255\000\000\006\255\000\000\252\254\
\007\255\009\255\000\000\000\000\000\255\000\000\252\254\005\255\
\000\000\000\000\000\000\003\255\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\251\255\000\000\000\000\001\000\004\000"

let yytablesize = 17
let yytable = "\011\000\
\012\000\013\000\001\000\002\000\012\000\013\000\020\000\021\000\
\004\000\006\000\009\000\010\000\016\000\017\000\022\000\019\000\
\018\000"

let yycheck = "\004\001\
\005\001\006\001\001\000\002\000\005\001\006\001\002\001\003\001\
\006\001\006\001\001\001\006\001\006\001\005\001\020\000\015\000\
\013\000"

let yyact = [|
  (fun _ -> failwith "parser")
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 :  int ) in
    let _3 = (peek_val parser_env 1 :  int ) in
    Obj.repr((
# 27 "gparser.mly"
                                     [(_1,_3)] ) :  (int * int) list ))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 :  int ) in
    let _3 = (peek_val parser_env 2 :  int ) in
    let _5 = (peek_val parser_env 0 :  (int * int) list ) in
    Obj.repr((
# 28 "gparser.mly"
                                               (_1, _3) :: _5 ) :  (int * int) list ))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'header) in
    let _2 = (peek_val parser_env 0 : 'line_list) in
    Obj.repr((
# 31 "gparser.mly"
                               Graph.make (tab_of_list 
					     !n 
					     (Array.make !d sharp)
                                             _2)
			     ) :  Graph.graph ))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 :  int ) in
    let _2 = (peek_val parser_env 1 :  int ) in
    Obj.repr((
# 37 "gparser.mly"
                           n := _1; d := _2 ) : 'header))
; (fun parser_env ->
    Obj.repr((
# 39 "gparser.mly"
                             [] ) : 'line_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'line) in
    let _2 = (peek_val parser_env 0 : 'line_list) in
    Obj.repr((
# 40 "gparser.mly"
                             match _1 with
				 [] -> _2
			       | l  -> (tab_of_list !d sharp _1) :: _2
			   ) : 'line_list))
; (fun parser_env ->
    Obj.repr((
# 45 "gparser.mly"
                   [] ) : 'line))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 :  int ) in
    let _2 = (peek_val parser_env 0 : 'line) in
    Obj.repr((
# 46 "gparser.mly"
                   _1 :: _2 ) : 'line))
(* Entry edge_list *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
(* Entry raw_graph *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
|]
let yytables =
  { actions=yyact;
    transl_const=yytransl_const;
    transl_block=yytransl_block;
    lhs=yylhs;
    len=yylen;
    defred=yydefred;
    dgoto=yydgoto;
    sindex=yysindex;
    rindex=yyrindex;
    gindex=yygindex;
    tablesize=yytablesize;
    table=yytable;
    check=yycheck;
    error_function=parse_error }
let edge_list (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 1 lexfun lexbuf :  (int * int) list )
let raw_graph (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 2 lexfun lexbuf :  Graph.graph )
