(* fonctions de manipulation des graphes *)

type graph = { tab : int array array;
	       mutable pos : (int * int) array
	     }

val sharp : int

val help : unit -> unit

val make : int array array -> graph 
val size : graph -> int
val degree : graph -> int
val tab : graph -> int array array
val pos : graph -> (int * int) array
val recomputepos : graph -> unit

val nboors : graph -> int -> int array 
val is_nboor : graph -> int -> int -> bool
val h_vector : graph -> int -> int array
