type token =
    Edge
  | SemiColon
  | End
  | Eof
  | Newline
  | Int of ( int )

val edge_list :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf ->  (int * int) list 
val raw_graph :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf ->  Graph.graph 
